<?php

namespace Modules\FIN\Services;

use Doctrine\ORM\EntityManager;
use Modules\FIN\Factory\TitulosAReceberFactory;

/**
 * Class TitulosAReceberService
 * @package Modules\FIN\Services
 */
class TitulosAReceberService {

    protected $entityManager;
    protected $titulosAReceberFactory;

    /**
     * @param EntityManager             $entityManager
     * @param Environment               $environment
     * @param TitulosAReceberFactory    $titulosAReceberFactory
     */
    public function __construct(EntityManager $entityManager, TitulosAReceberFactory $titulosAReceberFactory) {
        $this->entityManager             = $entityManager;
        $this->titulosAReceberFactory    = $titulosAReceberFactory;
    }

    /**
     * Gera Títulos por Assinatura
     * @param $cdfilial
     * @param $nrcpfrespcon
     * @param $nrservasscli
     * @throws \Exception
     */
    public function geraTitulosPorAssinatura($cdfilial, $nrcpfrespcon, $nrservasscli) {
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        try {
            
            // Executa Procedure Gera Boletos Assinatura
            $this->titulosAReceberFactory->execProcGeraBoletosAssinatura($cdfilial, $nrcpfrespcon, $nrservasscli);
            
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollBack();
            throw $e;
        }
    }

}